#! /usr/bin/env node
"use strict";

var _bluebirdLstC;

function _load_bluebirdLstC() {
    return _bluebirdLstC = require("bluebird-lst-c");
}

let main = (() => {
    var _ref = (0, (_bluebirdLstC || _load_bluebirdLstC()).coroutine)(function* () {
        const arch = args.arch || process.arch;
        (0, (_log || _load_log()).log)(`Execute node-gyp rebuild for arch ${ arch }`);
        yield (0, (_util || _load_util()).exec)(process.platform === "win32" ? "node-gyp.cmd" : "node-gyp", ["rebuild"], {
            env: (0, (_util || _load_util()).getGypEnv)((yield (0, (_util || _load_util()).getElectronVersion)((yield (0, (_readPackageJson || _load_readPackageJson()).readPackageJson)(devPackageFile)), devPackageFile)), arch)
        });
    });

    return function main() {
        return _ref.apply(this, arguments);
    };
})();

var _util;

function _load_util() {
    return _util = require("./util/util");
}

var _promise;

function _load_promise() {
    return _promise = require("./util/promise");
}

var _path;

function _load_path() {
    return _path = _interopRequireWildcard(require("path"));
}

var _yargs;

function _load_yargs() {
    return _yargs = _interopRequireDefault(require("yargs"));
}

var _readPackageJson;

function _load_readPackageJson() {
    return _readPackageJson = require("./util/readPackageJson");
}

var _log;

function _load_log() {
    return _log = require("./util/log");
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

const args = (_yargs || _load_yargs()).default.option("arch", {
    choices: ["ia32", "x64", "armv7l"]
}).argv;
const projectDir = process.cwd();
const devPackageFile = (_path || _load_path()).join(projectDir, "package.json");

main().catch((_promise || _load_promise()).printErrorAndExit);
//# sourceMappingURL=node-gyp-rebuild.js.map